dofile "slib.lua"

--filename = "..\\clara\\scripts\\clara.lua"

temp = io.open ("temp.lua", "w")
file = io.open (filename, "w")
if not file then
	error ("    "..filename)
	
end


function dofile_add (filename)
	for s in io.lines (filename) do
		if string.sub (s, 1, 6) == "dofile" then
			dofile_add (string.sub (s, 9, -2))
		else
			file:write (s, "\n")
		end
	end
end

dofile_add "if.lua"

file:write ("world.items = {}\n")

function process_node (node, parent)
	if parent then
		if node.parent == parent then
			file:write (parent.uid..":create ('"..node.uid.."', '"..node.name.."')\n")
		else
			temp:write (parent.uid..":add("..node.uid..")\n")
		end
	end

	

	if node.ide_data then
		local text
		for k, v in pairs( node.ide_data ) do
			if k ~= "constructor" and k ~= "hooks" then
				file:write ("function "..node.uid..":"..k.." (event)\n"..v.."\nend\n")
			elseif k == "constructor" then
				file:write ("function "..node.uid..":"..k.." ()\n"..v.."\nend\n", "\n")
				temp:write (node.uid..":constructor ()\n")
			else
				file:write (node.uid..":add (function (event)\n"..v.."\nend)\n")
			end
		end
	end

	file:write (node.uid..".data = ")
	dump_table (node.data, file)

	if node.items then
		for i, v in ipairs(node.items) do
			process_node (v, node)
		end
	end
end

process_node (world)



temp:close ()
for s in io.lines ("temp.lua") do
	file:write (s.."\n")
end

temp = "PARSE_ERROR = {"
for i=1,9 do
	temp = temp.."[["..string.gsub (PARSE_ERROR [i], "\r", "").."]],"
end
temp = temp.."}"
file:write (temp)

file:close ()

file = io.open(filename)
s = string.gsub(file:read "*a", "\r", "")
file:close()
file = io.open (filename, "w")
file:write(s)
file:close()
