file = io.open (filename, "a+")

function process_node (node)
	file:write (node.uid..".data = ")
	dump_table (node.data, file)

	if node.items then
		for i, v in ipairs(node.items) do
			process_node (v)
		end
	end

end

process_node (world)

temp = "PARSE_ERROR = {"
for i=1,9 do
	temp = temp.."[["..string.gsub (PARSE_ERROR [i], "\r", "").."]],"
end
temp = temp.."}"
file:write (temp)

file:write "\nIDE_MAP = clone (IDE_MAP, "
dump_table (IDE_MAP, file)
file:write ")\nIDE_MAP:update ()\nIDE_MAP:select (1)"
file:close()